/*************************************************************
  Download latest Blynk library here:
    https://github.com/blynkkk/blynk-library/releases/latest

  Blynk is a platform with iOS and Android apps to control
  Arduino, Raspberry Pi and the likes over the Internet.
  You can easily build graphic interfaces for all your
  projects by simply dragging and dropping widgets.

    Downloads, docs, tutorials: http://www.blynk.cc
    Sketch generator:           http://examples.blynk.cc
    Blynk community:            http://community.blynk.cc
    Follow us:                  http://www.fb.com/blynkapp
                                http://twitter.com/blynk_app

  Blynk library is licensed under MIT license
  This example code is in public domain.

 *************************************************************
  WARNING!
    It's very tricky to get it working. Please read this article:
    http://help.blynk.cc/hardware-and-libraries/arduino/esp8266-with-at-firmware

  Rotate a servo using a slider!

  App project setup:
    Slider widget (0...180) on V3
 *************************************************************/

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT Serial

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>
int servoPin = 9; 
int distance, initialDistance, currentDistance, i;

int pos = 0;
// You should get Auth Token in the Blynk App.
// Go to the Project Settings (nut icon).
char auth[] = "YourAuthToken";

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "******";
char pass[] = "******";

// Hardware Serial on Mega, Leonardo, Micro...
//#define EspSerial Serial1

// or Software Serial on Uno, Nano...
#include <SoftwareSerial.h>
SoftwareSerial EspSerial(A9, A8); // RX, TX

ESP8266 wifi(&EspSerial);

BLYNK_WRITE(V8)
{
  int pinValue = param.asInt();
  //switchState = pinValue; // read the pushButton State

 if (pinValue == HIGH)
 {
   for(int i=0;i<50;i++){
    int pulsewidth = (90 * 11) + 500; 
    digitalWrite(servoPin, HIGH);   
    delayMicroseconds(pulsewidth);  
    digitalWrite(servoPin, LOW);   
    delayMicroseconds(20000 - pulsewidth);
  }
 } 
 else if(pinValue == LOW)
 {
  for(int i=0;i<50;i++){
    int pulsewidth = (0 * 11) + 500; 
    digitalWrite(servoPin, HIGH);  
    delayMicroseconds(pulsewidth);  
    digitalWrite(servoPin, LOW);   
    delayMicroseconds(20000 - pulsewidth);
  }
}
}


void setup()
{
  // Debug console
  Serial.begin(9600);
  pinMode(servoPin, OUTPUT); //Set the servo interface as the output interface
 while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  Serial.println("start");
  // set the data rate for the SoftwareSerial port
  EspSerial.begin(115200);
  EspSerial.write("AT+UART_DEF=9600,8,1,0,0\r\n");
  EspSerial.write("AT+RST\r\n");
  delay(100);
  EspSerial.begin(9600);

  Blynk.begin(auth, wifi, ssid, pass);
  // You can also specify server:
  //Blynk.begin(auth, wifi, ssid, pass, "blynk-cloud.com", 80);
  //Blynk.begin(auth, wifi, ssid, pass, IPAddress(192,168,1,100), 8080);
}

void loop()
{
  Blynk.run();
}
